<?php
/**
 * Created by JetBrains PhpStorm.
 * User: gustavoavila
 * Date: 26/10/12
 * Time: 10:44
 * To change this template use File | Settings | File Templates.
 */
class ger80900_07Logic extends FctLogic
{

    static $_storedInSession = array("CDREGRAFISC");

    public function __construct($useSession = true)
    {
        parent::__construct();
        if($useSession) {
            parent::storedInSession(self::$_storedInSession, ger80900_01::WINDOW_NAME);
        }
    }

    public function importTo($cdregrafisc)
    {
        if(isset($cdregrafisc)) {
            $columns = array();
            $cdinscesta = $this->getCdinscesta();
            if (!empty($cdinscesta)) {
                $columns["CDINSCESTA"] = $cdinscesta;
            }
            $tipooperac = $this->getCdtipooperac();
            if (!empty($tipooperac)) {
                $columns["CDTIPOOPER"] = $tipooperac;
            }
            $grupofisc = $this->getCdgrupofisc();
            if (!empty($grupofisc)) {
                $columns["CDGRUPOFISC"] = $grupofisc;
            }

            try{
                $this->validateImport($columns);
                $this->import($columns, $cdregrafisc);
            } catch(Exception $e) {
                throw $e;
            }
        }
        $a = 1;
    }

    private function validateImport($columns)
    {
        if(empty($columns)) throw new Exception("Nothing to import.");
        $refCount = count(current($columns));
        foreach($columns as $rows) {
            if(count($rows) !== $refCount) throw new Exception("Qtde. a importar de insc. estadual, tipo de operação e grupos fiscais devem ser a mesma.");
        }
    }

    private function import($columns, $cdregrafisc)
    {
        $importRow = array(
            "CDREGRAFISC" => $cdregrafisc,
            "CDEMPRESA" => $this->getCdempresa(),
            "NRORDPRIORIDADE" => 1
        );

        $dataFim = $this->getDatafim();
        if($dataFim) {
            $importRow["DTVALVINCFISC"] = $dataFim;
        }

        $refCount = count(current($columns));
        for($i=0; $i<$refCount; $i++) {
            try{
                $importRow["NRVINCFISCREGRA"] = VinculofisregraLogic::geraNovoCodigo();
                if(isset($columns["CDINSCESTA"])) $importRow["CDINSCESTA"] = $columns["CDINSCESTA"][$i]["cdinscesta"];
                if(isset($columns["CDTIPOOPER"])) $importRow["CDTIPOOPER"] = $columns["CDTIPOOPER"][$i]["cdtipooper"];
                if(isset($columns["CDGRUPOFISC"])) $importRow["CDGRUPOFISC"] = $columns["CDGRUPOFISC"][$i]["cdgrupofisc"];
                FctDb::insert("VINCULOFISREGRA", $importRow);
            } catch(Exception $e) {
                throw $e;
            }
        }
    }

}
