/* Sistemas Integrados TEKNISA
   Gesto Consolidada

Nome: 0012_STPTEKO_ETL_COMERCIAL.sql
                                                                            
Descrio:                                                                 
Procedure para preencher os fatos da tabela ETLCOMERCIAL a partir dos dados
apurados dos contatos registrados no sistema interno Teknisa.

Criao:                                                                   
17/01/2007 Raphael Ernani
Alterao:
25/01/2007 Raphael Ernani - Incluso da Dimenso Produto Comercial e do Item "No Lido" na dimenso Aprovao
05/03/2008 Leonardo Bispo - Incluso da Dimenso Motivo de Encerramento de Contato

*/
create or replace
PROCEDURE      "ETL_COMERCIAL" 
                    (P_DTINI  IN DATE,
                     P_DTFINA IN DATE)
IS
 V_DTFIM           DATE;
 V_DTINI           DATE;
 V_NRSEQFATCOM     VARCHAR2(12);
 V_CDSEQUENCIAL    VARCHAR2(20);
 V_NIVEL           VARCHAR2(20);
 V_DTANO           VARCHAR2(04);
 V_NMCONTACTADO    VARCHAR2(100);
 V_IDCONTAPROV     VARCHAR2(10);
 V_IDSTATUSCONT    VARCHAR2(12);
 V_TIPOCONTATADO   VARCHAR2(10);
 V_CDPAIS          PAIS.CDPAIS%TYPE;
 V_SGESTADO        ESTADO.SGESTADO%TYPE;
 V_CDMUNICIPIO     MUNICIPIO.CDMUNICIPIO%TYPE;

 CON_SIM           VARCHAR2(3)  := 'Sim';
 CON_NAO           VARCHAR2(3)  := 'No';
 CON_NAO_LIDO      VARCHAR2(10) := 'No Lido';
 CON_CONCLUIDO     VARCHAR2(9)  := 'Concludo';
 CON_ANDAMENTO     VARCHAR2(12) := 'Em Andamento';
 CON_PROSPECT      VARCHAR2(08) := 'Prospect';
 CON_CLIENTE       VARCHAR2(07) := 'Cliente';
 CON_FORNECEDOR    VARCHAR2(10) := 'Fornecedor';
 CON_VENDEDOR      VARCHAR2(08) := 'Vendedor';

 V_DTFINA          DATE;
 V_DTINICIAL       DATE;
 V_DSPERIODO       VARCHAR2(25);
BEGIN
   IF TO_CHAR(P_DTINI,'DD') <>'21' THEN             
       IF TO_NUMBER(TO_CHAR(P_DTINI,'DD')) < 21 THEN                      
        V_DTINI  := '21/' || TO_CHAR(ADD_MONTHS(P_DTINI,-1),'MM/YYYY');
       ELSE
         V_DTINI  := '21/' || TO_CHAR(P_DTINI,'MM/YYYY');       
       END IF;      
   ELSE
      V_DTINI  :=  P_DTINI;
   END IF;
         IF TO_CHAR(P_DTFINA,'DD') <>'20' THEN             
            IF TO_NUMBER(TO_CHAR(P_DTFINA,'DD')) > 20 THEN                   
               V_DTFINA  := '20/' || TO_CHAR(ADD_MONTHS(P_DTFINA,1),'MM/YYYY');
            ELSE
               V_DTFINA  := '20/' || TO_CHAR(P_DTFINA,'MM/YYYY');
          END IF;      
         ELSE
            V_DTFINA  :=  P_DTFINA;
         END IF;        
   
   V_DTINICIAL := TO_DATE(V_DTINI,'DD/MM/YYYY');

     DELETE FROM ETLCOMERCIAL
     WHERE DTINICIOCOM >= V_DTINICIAL;
     COMMIT;

   BEGIN
      SELECT NVL(MAX(LPAD(NRSEQFATCOM,12,0)),0)
      INTO   V_NRSEQFATCOM
      FROM   ETLCOMERCIAL;
   EXCEPTION
   WHEN OTHERS THEN
      V_NRSEQFATCOM := '0';
   END;
   WHILE (V_DTINI  <=  V_DTFINA) LOOP
      V_DTFIM := '20/' || TO_CHAR(ADD_MONTHS(V_DTINI,1),'MM/YYYY') ;
      FOR C_ETL IN
            (SELECT COUNT(CON.CDFILIAL||CON.NRCONTATO||EVO.NRSEQEVOLCON) AS QTCONTATOS, CON.CDFILIAL,
                   CON.CDMOTICONT, CON.IDSTATUSCONT, CON.CDCLIENTE,
                   CON.CDFORNECED, CON.CDPROSPECT, CON.CDVENDEDOR, CON.IDTPCONTATO,
                   CON.CDSISTEMA, CON.CDOPCONCCONT, CON.IDCONTAPROV, EVO.CDOPEREVOL,
                   EVO.CDMOTIEVOCON, SIS.CDPROCOMERCI, CON.CDMTENCECONT
             FROM
                   CONTATO CON, EVOLCONT EVO, SISTEMA SIS
             WHERE
                   (trunc(EVO.DTHREVOLCONT)  BETWEEN V_DTINI AND V_DTFIM)
               AND (EVO.CDFILIAL (+)    = CON.CDFILIAL)
               AND (EVO.NRCONTATO(+)    = CON.NRCONTATO)
               AND (SIS.CDSISTEMA(+)    = CON.CDSISTEMA)
             GROUP BY
                   CON.CDFILIAL, CON.CDMOTICONT, CON.IDSTATUSCONT, CON.CDCLIENTE,
                   CON.CDFORNECED, CON.CDPROSPECT, CON.CDVENDEDOR, CON.IDTPCONTATO,
                   CON.CDSISTEMA, CON.CDOPCONCCONT, CON.IDCONTAPROV, EVO.CDOPEREVOL,
                   EVO.CDMOTIEVOCON, SIS.CDPROCOMERCI, CON.CDMTENCECONT
             )
      LOOP

             IF C_ETL.CDMOTIEVOCON<>'12' THEN
                V_IDCONTAPROV := CON_NAO_LIDO;
             ELSE
                IF C_ETL.IDCONTAPROV = 'S' THEN
                   V_IDCONTAPROV := CON_SIM;
                ELSIF C_ETL.IDCONTAPROV = 'N' THEN
                   V_IDCONTAPROV := CON_NAO;
                ELSE V_IDCONTAPROV := CON_NAO_LIDO;
                END IF;
             END IF;
             IF C_ETL.IDSTATUSCONT = 'C' THEN
                V_IDSTATUSCONT := CON_CONCLUIDO;
             ELSE
                V_IDSTATUSCONT := CON_ANDAMENTO;
             END IF;

             IF C_ETL.IDTPCONTATO='C' THEN
                V_TIPOCONTATADO  := CON_CLIENTE;
                BEGIN
                   SELECT NMFANTCLIE
                   INTO V_NMCONTACTADO
                   FROM CLIENTE
                   WHERE CDCLIENTE = C_ETL.CDCLIENTE;
                EXCEPTION
                WHEN OTHERS THEN
                   V_NMCONTACTADO := NULL;
                END;
                BEGIN
                   SELECT CDPAIS,SGESTADO,CDMUNICIPIO
                   INTO V_CDPAIS,V_SGESTADO,V_CDMUNICIPIO
                   FROM ENDECLIE
                   WHERE (CDCLIENTE = C_ETL.CDCLIENTE) AND
                   (IDTPENDECLIE = 'P');
                EXCEPTION
                WHEN OTHERS THEN
                   BEGIN
                      V_CDPAIS := NULL;
                      V_SGESTADO := NULL;
                      V_CDMUNICIPIO := NULL;
                   END;
                END;
             ELSIF C_ETL.IDTPCONTATO='P' THEN
                   V_TIPOCONTATADO  := CON_PROSPECT;
                   BEGIN
                      SELECT NMFANTPROS
                      INTO V_NMCONTACTADO
                      FROM PROSPECT
                      WHERE (CDPROSPECT = C_ETL.CDPROSPECT)  ;
                      EXCEPTION
                      WHEN OTHERS THEN
                         V_NMCONTACTADO := NULL;
                   END;
                   BEGIN
                      SELECT CDPAIS,SGESTADO,CDMUNICIPIO
                      INTO V_CDPAIS,V_SGESTADO,V_CDMUNICIPIO
                      FROM ENDEPROSPECT
                      WHERE CDPROSPECT = C_ETL.CDPROSPECT AND
                      (IDTPENDEPROS = 'P');
                      EXCEPTION WHEN OTHERS THEN BEGIN
                         V_CDPAIS := NULL;
                         V_SGESTADO := NULL;
                         V_CDMUNICIPIO := NULL;
                      END;
                   END;
             ELSIF C_ETL.IDTPCONTATO='F' THEN
                   V_TIPOCONTATADO  := CON_FORNECEDOR;
                   BEGIN
                      SELECT NMFANTFORN
                      INTO V_NMCONTACTADO
                      FROM FORNECEDOR
                      WHERE (CDFORNECED = C_ETL.CDFORNECED) ;
                      EXCEPTION
                      WHEN OTHERS THEN
                         V_NMCONTACTADO := NULL;
                   END;
                   BEGIN
                      SELECT CDPAIS,SGESTADO,CDMUNICIPIO
                      INTO V_CDPAIS,V_SGESTADO,V_CDMUNICIPIO
                      FROM ENDEFORN
                      WHERE CDFORNECED = C_ETL.CDFORNECED AND
                      (IDTPENDEFORN = 'P');
                      EXCEPTION WHEN OTHERS THEN BEGIN
                         V_CDPAIS := NULL;
                         V_SGESTADO := NULL;
                         V_CDMUNICIPIO := NULL;
                      END;
                   END;
             ELSIF C_ETL.IDTPCONTATO='V' THEN
                   V_TIPOCONTATADO  := CON_VENDEDOR;
                   BEGIN
                      SELECT NMFANVEN
                      INTO V_NMCONTACTADO
                      FROM VENDEDOR
                      WHERE CDVENDEDOR = C_ETL.CDVENDEDOR;
                      EXCEPTION
                      WHEN OTHERS THEN
                         V_NMCONTACTADO := NULL;
                   END;
                   BEGIN
                      SELECT CDPAIS,SGESTADO,CDMUNICIPIO
                      INTO   V_CDPAIS,V_SGESTADO,V_CDMUNICIPIO
                      FROM   ENDEVENDE
                      WHERE  CDVENDEDOR = C_ETL.CDVENDEDOR
                         AND IDTPENDEVEN = 'P';
                      EXCEPTION WHEN OTHERS THEN BEGIN
                         V_CDPAIS := NULL;
                         V_SGESTADO := NULL;
                         V_CDMUNICIPIO := NULL;
                      END;
                   END;
             END IF;
             V_DTANO  :=  TO_CHAR(V_DTINI,'YYYY');
             V_DSPERIODO := TO_CHAR(V_DTINI ||'  ' || V_DTFIM);
             V_DTINICIAL := TO_DATE(V_DTINI,'DD/MM/YYYY');

             V_NRSEQFATCOM := LPAD(V_NRSEQFATCOM + 1, 12 ,'0');
                                       INSERT INTO ETLCOMERCIAL
                     (
                     NRSEQFATCOM,         QTCONTATOS,            CDFILIAL,                           
                     CDMOTICONT,           IDCONTAPROV,          IDSTATUSCONT,
                     CDSISTEMA,            ANFATCOM,             DTINICIOCOM,
                     CDOPEREVOL,           CDMOTIEVOCON,         NMCONTATO,
                     CDPAIS,               SGESTADO,             CDMUNICIPIO,
                     CDPROCOMERCI,         DSTPCONTATO,          CDMTENCECONT,
                     DSPERIFATETLCOM                      
                     )
             VALUES
                     (
                     V_NRSEQFATCOM,       C_ETL.QTCONTATOS,     C_ETL.CDFILIAL,                       
                     C_ETL.CDMOTICONT,     V_IDCONTAPROV,        V_IDSTATUSCONT,
                     C_ETL.CDSISTEMA,      V_DTANO,              V_DTINICIAL,
                     C_ETL.CDOPEREVOL,     C_ETL.CDMOTIEVOCON,   V_NMCONTACTADO,
                     V_CDPAIS,             V_SGESTADO||V_CDPAIS, V_CDMUNICIPIO||V_SGESTADO||V_CDPAIS,                      C_ETL.CDPROCOMERCI,   V_TIPOCONTATADO,      C_ETL.CDMTENCECONT,
                     V_DSPERIODO
                     );
      COMMIT;
      END LOOP;
      V_DTINI := ADD_MONTHS(V_DTINI,1);
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ETL_COMERCIAL','5.01.009'); END;
/
