IF EXISTS(SELECT NAME
         FROM SYSOBJECTS
        WHERE NAME = 'CTB_REC_BAIXA' AND TYPE = 'P')
DROP PROCEDURE CTB_REC_BAIXA
GO

CREATE PROCEDURE CTB_REC_BAIXA
   @P_NRLANCCTBTEMP VARCHAR(12),
   @P_CDEMPRESA VARCHAR(02),
   @P_CDFILIAL VARCHAR(04),
   @P_FILIPROC VARCHAR(04),
   @P_NRBAIXA VARCHAR(10),
   @P_NRLANCCTB VARCHAR(12) OUTPUT
AS
   DECLARE @V_DTBAIXA DATETIME;
   DECLARE @V_CDREDUCONT VARCHAR(03);
   DECLARE @V_CDTPBAIXA VARCHAR(02);
   DECLARE @V_VRBAIXAREC FLOAT;
   DECLARE @V_DOCUMENTO VARCHAR(10);
   DECLARE @V_IDCTBAJCTREC VARCHAR(01);

   DECLARE @V_STATUS VARCHAR(01);
   DECLARE @V_CONTAJUST INT;
   DECLARE @V_DATAAUX VARCHAR(20);
   DECLARE @V_NRLANCTEMP VARCHAR(20);
   DECLARE @V_CONTRAT VARCHAR(01);
   DECLARE @V_CDHISTINT VARCHAR(04);
   DECLARE @V_DSHISTINT VARCHAR(200);
   DECLARE @V_CDHISTPADR VARCHAR(04);
   DECLARE @V_CDCENTCUST VARCHAR(04);
   DECLARE @V_CDFILIAL VARCHAR(04);
   DECLARE @V_DSHISTPADR VARCHAR(200);
   DECLARE @V_SEQPARTIDA INT;
   DECLARE @V_PARTIDAAUX VARCHAR(05);
   DECLARE @V_VRPARTIDA FLOAT;
   DECLARE @V_RATSEQ INT;
   DECLARE @V_IDCOME VARCHAR(01);
   DECLARE @V_IDCCUS VARCHAR(01);
   DECLARE @V_RATSEQAUX VARCHAR(05);
   DECLARE @V_CDCONTCTBL VARCHAR(20);
   DECLARE @V_BOVENDAFOS VARCHAR(01);
   DECLARE @V_CDFILIALBOL VARCHAR(04);
   DECLARE @V_NRLANBOLREC VARCHAR(10);
   DECLARE @V_CODCOMEAUX VARCHAR(21);
   DECLARE @V_VRTOTALAJUSNCTB FLOAT;
   DECLARE @V_ENTROULOOP VARCHAR(01);
   DECLARE @V_FATOR INT;

   /* VARIAVEIS DO CURSOR C_CONTAS */
   DECLARE @C_CONTAS_CDFILIAL VARCHAR(04);
   DECLARE @C_CONTAS_NRLANCTONF VARCHAR(10);
   DECLARE @C_CONTAS_NRSEQVENREC VARCHAR(02);
   DECLARE @C_CONTAS_NRPARCELAREC VARCHAR(02);
   DECLARE @C_CONTAS_CDFILBOL VARCHAR(04);
   DECLARE @C_CONTAS_NRLANBOLREC VARCHAR(10);
   DECLARE @C_CONTAS_CDCLIENTE VARCHAR(21);
   DECLARE @C_CONTAS_CDTPCTRECEB VARCHAR(06);
   DECLARE @C_CONTAS_CDCONTCTBL VARCHAR(20);
   DECLARE @C_CONTAS_CDHISTPADR VARCHAR(04);
   DECLARE @C_CONTAS_DSHISTPADR VARCHAR(200);
   DECLARE @C_CONTAS_CDFILIEMIT VARCHAR(04);
   DECLARE @C_CONTAS_NRNOTAFISC VARCHAR(20);
   DECLARE @C_CONTAS_VRATUAREC FLOAT;
   DECLARE @C_CONTAS_IDCTBTPCNTBREC VARCHAR(01);
   DECLARE @C_CONTAS_VRBOLREC FLOAT;
   DECLARE @C_CONTAS_QTCONTAS INT;

   /* VARIAVEIS DO CURSOR C_RATEIO */
   DECLARE @C_RATEIO_CDCENTCUST VARCHAR(04);
   DECLARE @C_RATEIO_CDFIRATCTREC VARCHAR(04);
   DECLARE @C_RATEIO_VRRATCCCTREC FLOAT;

   /* VARIAVEIS DO CURSOR AJUSTE */
   DECLARE @AJUSTES_NRLANBOLREC VARCHAR(10);
   DECLARE @AJUSTES_CDFILIBAIREC VARCHAR(04);
   DECLARE @AJUSTES_CDFILIEMIT VARCHAR(04);
   DECLARE @AJUSTES_CDAJUCTREC VARCHAR(04);
   DECLARE @AJUSTES_CDREDUCONT VARCHAR(03);
   DECLARE @AJUSTES_CDCLIENTE VARCHAR(21);
   DECLARE @AJUSTES_VRAJBOLREC FLOAT;
   DECLARE @AJUSTES_IDAJUCTREC VARCHAR(01);
   DECLARE @AJUSTES_VRBOLREC FLOAT;
   DECLARE @AJUSTES_NRLANCTONF VARCHAR(10);
   DECLARE @AJUSTES_CDFILIAL VARCHAR(04);
   DECLARE @AJUSTES_CDHISTPADR VARCHAR(04);
   DECLARE @AJUSTES_NRSEQVENREC VARCHAR(02);
   DECLARE @AJUSTES_NRPARCELAREC VARCHAR(02);
   DECLARE @AJUSTES_VRATUAREC FLOAT;
   DECLARE @AJUSTES_CDCONTCTBL VARCHAR(20);

   DECLARE @V_VRAJUSTE FLOAT;
   DECLARE @V_COUNT INT;
   DECLARE @V_NRCONTABOL INT;
   DECLARE @V_VRSOMAAJUSNCTB FLOAT;
   DECLARE @V_VRAJUSNCTB FLOAT;
   DECLARE @V_TOTALRATEIO FLOAT;
   DECLARE @V_TOTAJUSTE FLOAT;
   DECLARE @V_TOTRATAJ FLOAT;


   /* VARIAVEIS DO CURSOR RATAJ */
   DECLARE @RATAJ_CDCENTCUST VARCHAR(04);
   DECLARE @RATAJ_CDFIRATTPAJR VARCHAR(04);
   DECLARE @RATAJ_CDFILIAL VARCHAR(04);
   DECLARE @RATAJ_VRPERATTPAJR FLOAT;

BEGIN
   SELECT @V_DTBAIXA = BR.DTBAIXAREC, @V_CDREDUCONT = BR.CDREDUCONT, @V_CDTPBAIXA = BR.CDTPBAIXAREC,
          @V_VRBAIXAREC = BR.VRBAIXAREC, @V_DOCUMENTO = BR.NRBAIXAREC, @V_STATUS = BR.IDSTATUSBREC,
          @V_IDCTBAJCTREC = TB.IDCTBLBXREC
     FROM BAIXARECEBIDA BR, TIPOBAIXAREC TB
    WHERE BR.CDFILIAL = @P_CDFILIAL
      AND BR.CDEMPRESA = @P_CDEMPRESA
      AND BR.NRBAIXAREC = @P_NRBAIXA
      AND BR.CDTPBAIXAREC = TB.CDTPBAIXAREC
      AND TB.IDCTBLBXREC = 'S';

   SELECT @V_CONTAJUST = COUNT(*)
     FROM BOLETRECEBER BO, AJBOLREC AJ, TIPOAJRECEBER TP
    WHERE BO.CDFILIBAIREC = @P_FILIPROC
      AND BO.NRBAIXAREC = @P_NRBAIXA
      AND BO.NRLANBOLREC = AJ.NRLANBOLREC
      AND BO.CDFILIAL = AJ.CDFILIAL
      AND AJ.CDAJUCTREC = TP.CDAJUCTREC
      AND TP.IDCTBAJCTREC = 'S';
   /* CASO O PARAMETRO DE NMERO DE LANAMENTO CONTBIL NO SEJA NULO,  PORQUE O LANAMENTO J EXISTIA.
      TENDO ASSIM QUE APAGAR O LANAMENTO PARA REFAZ-LO NA ROTINA                                    */
   IF @P_NRLANCCTBTEMP IS NOT NULL BEGIN
      /* DELETA OS RATEIOS DO LANAMENTO CONTBIL */
      DELETE
        FROM LANCCCUSTO
       WHERE NRLANCCONT = @P_NRLANCCTBTEMP
         AND CDEMPRESA  = @P_CDEMPRESA;

      /* DELETA AS PARTIDAS DO LANAMENTO CONTBIL */
      DELETE
        FROM LANCCONT
       WHERE NRLANCCONT = @P_NRLANCCTBTEMP
         AND CDEMPRESA  = @P_CDEMPRESA;
   END;

   SET @V_NRLANCTEMP = @P_NRLANCCTBTEMP;

   SELECT @V_COUNT = COUNT(*)
     FROM PARAMCTBL
    WHERE @V_DTBAIXA >= DTINTCTBREC;

   IF @V_COUNT > 0 BEGIN
      IF @V_STATUS <> 'P' AND @V_IDCTBAJCTREC = 'S' BEGIN
         /* CASO A VARIVEL QUE RECEBE O NMERO DO LANAMENTO CONTBIL SEJA NULA,  PORQUE O LANAMENTO CONTBIL  NOVO. */
         IF @V_NRLANCTEMP IS NULL BEGIN
            /* PEGA UM NOVO NMERO DE LANAMENTO CONTBIL, CASO O LANAMENTO NO REC SEJA NOVO */
            SET @V_DATAAUX = SUBSTRING(CONVERT(VARCHAR, @V_DTBAIXA, 103), 7, 4) + SUBSTRING(CONVERT(VARCHAR, @V_DTBAIXA, 103), 4, 2);
            SET @V_DATAAUX = 'LANCCONTABIL' + @P_CDEMPRESA + @V_DATAAUX;

            EXEC NOVO_CODIGO @V_DATAAUX, @P_SEQUENCIAL = @V_NRLANCTEMP OUTPUT;
            SET @V_DATAAUX = SUBSTRING(CONVERT(VARCHAR, @V_DTBAIXA, 103), 7, 4) + SUBSTRING(CONVERT(VARCHAR, @V_DTBAIXA, 103), 4, 2);
            SET @V_NRLANCTEMP = @V_DATAAUX + SUBSTRING(@V_NRLANCTEMP, 15, 6);
         END;

         IF (@V_VRBAIXAREC <> 0 OR @V_CONTAJUST <> 0) BEGIN
            SELECT @V_CONTRAT = IDCONTGERE
              FROM CONTOPECTBL
             WHERE CDEMPRESA = @P_CDEMPRESA;

            SELECT @V_CDHISTINT = H.CDHISTPADR, @V_DSHISTINT = HP.DSHISTPADR
              FROM HISTINTEGRA H, HISTPADR HP
             WHERE H.CDHISTPADR = HP.CDHISTPADR
               AND CDOPERACAO = 'BAIXAR';

            /* SELECIONA O HISTRICO PADRO RELACIONADO  BAIXA */
            SELECT @V_CDHISTPADR = T.CDHISTPADR, @V_DSHISTPADR = H.DSHISTPADR
              FROM TIPOBAIXAREC T, HISTPADR H
             WHERE T.CDTPBAIXAREC = @V_CDTPBAIXA
               AND T.CDHISTPADR   = H.CDHISTPADR;

            IF @V_CDHISTPADR IS NULL BEGIN
               SET @V_CDHISTPADR = @V_CDHISTINT;
               SET @V_DSHISTPADR = @V_DSHISTINT;
            END;
            SET @V_SEQPARTIDA = 0;

            IF @V_VRBAIXAREC <> 0 BEGIN
               SELECT @V_CDCONTCTBL = CC.CDCONTCTBL
                 FROM CONTCORR CC
                WHERE CC.CDREDUCONT = @V_CDREDUCONT;

               SELECT @V_IDCOME = ISNULL(IDTIPOCOME, 'N'), @V_IDCCUS = IDCONTCCUS
                 FROM CONTCTBL
                WHERE CDCONTCTBL = @V_CDCONTCTBL;

               IF @V_IDCOME <> 'B' BEGIN
                  SET @V_IDCOME = 'N';
                  SET @V_CDREDUCONT = NULL;
               END;

               SET @V_SEQPARTIDA = @V_SEQPARTIDA + 1;
               SET @V_PARTIDAAUX = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_SEQPARTIDA), 2);
               SET @V_VRPARTIDA = ROUND(@V_VRBAIXAREC * -1, 2);
               INSERT INTO LANCCTBTEMP
                  (CDEMPRESA, NRLANCCTBTEMP, CDDOCUTEMP, NRSEQCTBTEMP, CDCONTCTBL, CDHISTPADR,
                   DSHISTCTB, DTLANCCTBTEMP, VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, IDSISTEMA)
               VALUES
                  (@P_CDEMPRESA, @V_NRLANCTEMP, @V_DOCUMENTO, @V_PARTIDAAUX, @V_CDCONTCTBL, @V_CDHISTPADR,
                   'Recebimento', @V_DTBAIXA, @V_VRPARTIDA, @V_IDCOME, @V_CDREDUCONT, 'REC');

               IF @V_CONTRAT = 'S' BEGIN
                  IF @V_IDCCUS <> 'O' BEGIN
                     SET @V_RATSEQ = @V_RATSEQ + 1;
                     SET @V_RATSEQAUX = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_RATSEQ), 2);
                     SET @V_VRPARTIDA = ROUND(@V_VRBAIXAREC * -1, 2);

                     SELECT @V_CDCENTCUST = CDCENTCUST
                       FROM FILIAL
                      WHERE CDFILIAL = @P_FILIPROC;

                     IF @V_CDCENTCUST IS NULL BEGIN
                        SELECT @V_CDCENTCUST = CDCENTCUST
                          FROM EMPRESA
                         WHERE CDEMPRESA = @P_CDEMPRESA;
                     END;

                     INSERT INTO RATECTBTEMP
                        (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                     VALUES
                        (@P_CDEMPRESA, @V_NRLANCTEMP, @V_PARTIDAAUX, @P_FILIPROC, @V_CDCENTCUST,
                         @V_VRPARTIDA, @V_DTBAIXA, @V_RATSEQAUX);
                  END;
               END;
               SET @V_BOVENDAFOS = 'N';

               SET @V_CDFILIALBOL = 'XXXX';
               SET @V_NRLANBOLREC = 'XXXXXXXXXX';

               DECLARE C_CONTAS CURSOR FOR
                  SELECT CT.CDFILIAL, CT.NRLANCTONF, CT.NRSEQVENREC, CT.NRPARCELAREC,
                         B.CDFILIAL AS CDFILBOL, B.NRLANBOLREC, B.CDCLIENTE, CT.CDTPCTRECEB, TP.CDCONTCTBL,
                         TP.CDHISTPADR, H.DSHISTPADR, NF.CDFILIEMIT, NF.NRNOTAFISC,
                         CT.VRATUAREC,  IDCTBTPCNTBREC, B.VRBOLREC, COUNT(*) OVER(PARTITION BY B.CDFILIAL, B.NRLANBOLREC) AS QTCONTAS
                    FROM BOLETRECEBER B, CONTARECEBER CT, NOTAFISCAL NF, TIPOCTRECEBER TP LEFT JOIN HISTPADR H
                                                                                                 ON TP.CDHISTPADR = H.CDHISTPADR
                   WHERE B.CDFILIBAIREC = @P_CDFILIAL
                     AND B.NRBAIXAREC = @P_NRBAIXA
                     AND B.CDFILIAL = CT.CDFILIBOLREC
                     AND B.NRLANBOLREC = CT.NRLANBOLREC
                     AND CT.CDFILIAL = NF.CDFILIAL
                     AND CT.NRLANCTONF = NF.NRLANCTONF
                     AND CT.CDTPCTRECEB = TP.CDTPCTRECEB
                   ORDER BY B.CDFILIAL, B.NRLANBOLREC;
               OPEN C_CONTAS;
               FETCH NEXT FROM C_CONTAS INTO @C_CONTAS_CDFILIAL, @C_CONTAS_NRLANCTONF, @C_CONTAS_NRSEQVENREC, @C_CONTAS_NRPARCELAREC,
                                             @C_CONTAS_CDFILBOL, @C_CONTAS_NRLANBOLREC, @C_CONTAS_CDCLIENTE, @C_CONTAS_CDTPCTRECEB, @C_CONTAS_CDCONTCTBL,
                                             @C_CONTAS_CDHISTPADR, @C_CONTAS_DSHISTPADR, @C_CONTAS_CDFILIEMIT, @C_CONTAS_NRNOTAFISC,
                                             @C_CONTAS_VRATUAREC, @C_CONTAS_IDCTBTPCNTBREC, @C_CONTAS_VRBOLREC, @C_CONTAS_QTCONTAS;
               WHILE @@FETCH_STATUS = 0 BEGIN
                  IF @C_CONTAS_VRATUAREC <> 0 BEGIN
                     SELECT @V_COUNT = COUNT(*)
                       FROM MOVCAIXA
                      WHERE CDFILIALNF = @C_CONTAS_CDFILIAL
                        AND NRLANCTONF = @C_CONTAS_NRLANCTONF;
                     IF @V_COUNT > 0 BEGIN
                        SET @V_BOVENDAFOS = 'S';
                     END;

                     IF ((@C_CONTAS_IDCTBTPCNTBREC = 'S') OR (@V_BOVENDAFOS = 'S')) BEGIN
                        SET @V_CDCONTCTBL = @C_CONTAS_CDCONTCTBL;
                        SET @V_CDHISTPADR = @C_CONTAS_CDHISTPADR;
                        IF @V_CDHISTPADR IS NULL BEGIN
                           SET @V_DSHISTPADR = @V_DSHISTINT;
                           SET @V_CDHISTPADR = @V_CDHISTINT;
                        END;
                     END
                     ELSE BEGIN
                        EXEC CTB_CCCLIENTE @C_CONTAS_CDCLIENTE, @C_CONTAS_CDFILIEMIT, @P_CDEMPRESA, @P_CDCONTCTBL = @V_CDCONTCTBL OUTPUT;
                     END;

                     EXEC CTB_HIST_REC @V_CDHISTPADR, @C_CONTAS_CDFILIAL, @C_CONTAS_NRLANCTONF, @C_CONTAS_NRSEQVENREC, @C_CONTAS_NRPARCELAREC, '', @P_DSHISTPADR = @V_DSHISTPADR OUTPUT;

                     SELECT @V_IDCOME = ISNULL(IDTIPOCOME, 'N'), @V_IDCCUS = IDCONTCCUS
                       FROM CONTCTBL
                      WHERE CDCONTCTBL = @V_CDCONTCTBL;

                     IF @V_IDCOME <> 'C' BEGIN
                        SET @V_IDCOME = 'N';
                        SET @V_CODCOMEAUX = NULL;
                     END
                     ELSE BEGIN
                        SET @V_CODCOMEAUX = @C_CONTAS_CDCLIENTE;
                     END;

                     IF (@V_CDFILIALBOL <> @C_CONTAS_CDFILBOL) OR
                        (@V_NRLANBOLREC <> @C_CONTAS_NRLANBOLREC) BEGIN

                        SELECT @V_VRTOTALAJUSNCTB = SUM(CASE TA.IDAJUCTREC WHEN 'D' THEN AJ.VRAJBOLREC * -1 ELSE AJ.VRAJBOLREC END)
                          FROM AJBOLREC AJ, TIPOAJRECEBER TA
                         WHERE AJ.CDFILIAL = @C_CONTAS_CDFILBOL
                           AND AJ.NRLANBOLREC = @C_CONTAS_NRLANBOLREC
                           AND AJ.CDAJUCTREC = TA.CDAJUCTREC
                           AND TA.IDCTBAJCTREC = 'N';
                        IF @V_VRTOTALAJUSNCTB IS NULL BEGIN
                           SET @V_VRTOTALAJUSNCTB = 0;
                        END;
                        SET @V_NRCONTABOL = 1;
                        SET @V_VRSOMAAJUSNCTB = 0;
                        SET @V_VRAJUSNCTB = 0;
                        SET @V_CDFILIALBOL = @C_CONTAS_CDFILBOL;
                        SET @V_NRLANBOLREC = @C_CONTAS_NRLANBOLREC;
                     END
                     ELSE BEGIN
                        SET @V_NRCONTABOL = @V_NRCONTABOL +1;
                     END;
                     IF @V_VRTOTALAJUSNCTB <> 0 BEGIN
                        SET @V_VRAJUSNCTB = (@V_VRTOTALAJUSNCTB * 100) / @C_CONTAS_VRBOLREC;
                        SET @V_VRAJUSNCTB = ROUND((@V_VRAJUSNCTB * @C_CONTAS_VRATUAREC) / 100, 2);

                        SET @V_VRSOMAAJUSNCTB = @V_VRSOMAAJUSNCTB + @V_VRAJUSNCTB;

                        IF @V_NRCONTABOL = @C_CONTAS_QTCONTAS BEGIN
                           IF @V_VRTOTALAJUSNCTB <> @V_VRSOMAAJUSNCTB BEGIN
                              SET @V_VRAJUSNCTB = @V_VRAJUSNCTB + (@V_VRTOTALAJUSNCTB - @V_VRSOMAAJUSNCTB);
                           END;
                        END;
                     END;
                     IF @V_VRAJUSNCTB IS NULL BEGIN
                        SET @V_VRAJUSNCTB = 0;
                     END;
                     SET @V_VRPARTIDA = ROUND(@C_CONTAS_VRATUAREC + @V_VRAJUSNCTB, 2);

                     IF ISNULL(@V_VRPARTIDA, 0) <> 0 BEGIN
                        SET @V_SEQPARTIDA = @V_SEQPARTIDA + 1;
                        SET @V_PARTIDAAUX = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_SEQPARTIDA), 2);
                        INSERT INTO LANCCTBTEMP
                           (CDEMPRESA, NRLANCCTBTEMP, CDDOCUTEMP, NRSEQCTBTEMP, CDCONTCTBL, CDHISTPADR,
                            DSHISTCTB, DTLANCCTBTEMP, VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, IDSISTEMA)
                        VALUES
                           (@P_CDEMPRESA, @V_NRLANCTEMP, @V_DOCUMENTO, @V_PARTIDAAUX, @V_CDCONTCTBL, @V_CDHISTPADR,
                            @V_DSHISTPADR, @V_DTBAIXA, @V_VRPARTIDA, @V_IDCOME, @V_CODCOMEAUX, 'REC');
                        IF @V_CONTRAT = 'S' BEGIN
                           IF @V_IDCCUS <> 'O' BEGIN
                              SET @V_RATSEQ = 0;
                              SET @V_TOTALRATEIO = 0;
                              IF @C_CONTAS_IDCTBTPCNTBREC <> 'S' BEGIN
                                 SELECT @V_CDCENTCUST = CDCENTCUST
                                   FROM FILIAL
                                  WHERE CDFILIAL = @C_CONTAS_CDFILIEMIT;

                                 IF @V_CDCENTCUST IS NULL BEGIN
                                    SELECT @V_CDCENTCUST = CDCENTCUST
                                      FROM EMPRESA
                                     WHERE CDEMPRESA = @P_CDEMPRESA;
                                 END;


                                 SET @V_RATSEQ = @V_RATSEQ + 1;
                                 SET @V_RATSEQAUX = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_RATSEQ), 2);

                                 INSERT INTO RATECTBTEMP
                                    (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                                 VALUES
                                    (@P_CDEMPRESA, @V_NRLANCTEMP, @V_PARTIDAAUX, @C_CONTAS_CDFILIEMIT, @V_CDCENTCUST,
                                     @V_VRPARTIDA, @V_DTBAIXA, @V_RATSEQAUX);
                                 SET @V_TOTALRATEIO = @V_TOTALRATEIO + @V_VRPARTIDA;
                              END
                              ELSE BEGIN
                                 SET @V_ENTROULOOP = 'N';
                                 DECLARE C_RATEIO CURSOR FOR
                                    SELECT CDCENTCUST, CDFIRATCTREC, VRRATCCCTREC
                                     FROM RATCTRECEBER
                                    WHERE CDFILIAL = @C_CONTAS_CDFILIAL
                                      AND NRLANCTONF = @C_CONTAS_NRLANCTONF
                                      AND NRSEQVENREC = @C_CONTAS_NRSEQVENREC
                                      AND NRPARCELAREC = @C_CONTAS_NRPARCELAREC;
                                 OPEN C_RATEIO;
                                 FETCH NEXT FROM C_RATEIO INTO @C_RATEIO_CDCENTCUST, @C_RATEIO_CDFIRATCTREC, @C_RATEIO_VRRATCCCTREC;
                                 WHILE @@FETCH_STATUS = 0 BEGIN
                                    SET @V_ENTROULOOP = 'S';
                                    SET @V_RATSEQ = @V_RATSEQ + 1;
                                    SET @V_RATSEQAUX = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_RATSEQ), 2);
                                    SET @V_VRPARTIDA = ROUND(@C_RATEIO_VRRATCCCTREC, 2);
                                    INSERT INTO RATECTBTEMP
                                       (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                                    VALUES
                                       (@P_CDEMPRESA, @V_NRLANCTEMP, @V_PARTIDAAUX, @C_RATEIO_CDFIRATCTREC, @C_RATEIO_CDCENTCUST,
                                        @V_VRPARTIDA, @V_DTBAIXA, @V_RATSEQAUX);
                                    SET @V_TOTALRATEIO = @V_TOTALRATEIO +  ROUND(@C_RATEIO_VRRATCCCTREC, 2);
                                    SET @V_CDFILIAL = @C_RATEIO_CDFIRATCTREC;
                                    SET @V_CDCENTCUST = @C_RATEIO_CDCENTCUST;
                                    FETCH NEXT FROM C_RATEIO INTO @C_RATEIO_CDCENTCUST, @C_RATEIO_CDFIRATCTREC, @C_RATEIO_VRRATCCCTREC;
                                 END;
                                 IF @V_ENTROULOOP = 'N' BEGIN
                                    SELECT @V_CDCENTCUST = CDCENTCUST
                                      FROM FILIAL
                                     WHERE CDFILIAL = @C_CONTAS_CDFILIEMIT;

                                    IF @V_CDCENTCUST IS NULL BEGIN
                                       SELECT @V_CDCENTCUST = CDCENTCUST
                                         FROM EMPRESA
                                        WHERE CDEMPRESA = @P_CDEMPRESA;
                                    END;

                                    SET @V_RATSEQ = @V_RATSEQ + 1;
                                    SET @V_RATSEQAUX = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_RATSEQ), 2);

                                    INSERT INTO RATECTBTEMP
                                       (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                                    VALUES
                                       (@P_CDEMPRESA, @V_NRLANCTEMP, @V_PARTIDAAUX, @C_CONTAS_CDFILIEMIT, @V_CDCENTCUST,
                                        @V_VRPARTIDA, @V_DTBAIXA, @V_RATSEQAUX);
                                    SET @V_TOTALRATEIO = @V_TOTALRATEIO + ROUND(@C_CONTAS_VRATUAREC, 2);
                                    SET @V_CDFILIAL = @C_CONTAS_CDFILIEMIT;
                                    SET @V_CDCENTCUST = @V_CDCENTCUST;
                                 END;

                                 IF @V_TOTALRATEIO <> @V_VRPARTIDA BEGIN
                                    SET @V_VRPARTIDA = @V_TOTALRATEIO - @V_VRPARTIDA;
                                    SET @V_RATSEQ = @V_RATSEQ + 1;
                                    SET @V_RATSEQAUX = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_RATSEQ), 2);
                                    INSERT INTO RATECTBTEMP
                                       (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                                    VALUES
                                       (@P_CDEMPRESA, @V_NRLANCTEMP, @V_PARTIDAAUX, @V_CDFILIAL, @V_CDCENTCUST,
                                        @V_TOTALRATEIO, @V_DTBAIXA, @V_RATSEQAUX);
                                 END;
                              END;
                           END;
                        END;
                     END;
                  END;
                  FETCH NEXT FROM C_CONTAS INTO @C_CONTAS_CDFILIAL, @C_CONTAS_NRLANCTONF, @C_CONTAS_NRSEQVENREC, @C_CONTAS_NRPARCELAREC,
                                             @C_CONTAS_CDFILBOL, @C_CONTAS_NRLANBOLREC, @C_CONTAS_CDCLIENTE, @C_CONTAS_CDTPCTRECEB, @C_CONTAS_CDCONTCTBL,
                                             @C_CONTAS_CDHISTPADR, @C_CONTAS_DSHISTPADR, @C_CONTAS_CDFILIEMIT, @C_CONTAS_NRNOTAFISC,
                                             @C_CONTAS_VRATUAREC, @C_CONTAS_IDCTBTPCNTBREC, @C_CONTAS_VRBOLREC, @C_CONTAS_QTCONTAS;

               END;
               CLOSE C_CONTAS;
               DEALLOCATE C_CONTAS;
            END;

            /* ROTINA DE CONTABILIZAO DOS AJUSTES */
            DECLARE AJUSTES CURSOR FOR
               SELECT BO.NRLANBOLREC, BO.CDFILIBAIREC, NF.CDFILIEMIT, AJ.CDAJUCTREC,
                      BX.CDREDUCONT, BO.CDCLIENTE, AJ.VRAJBOLREC, IDAJUCTREC, BO.VRBOLREC,
                      CT.NRLANCTONF, CT.CDFILIAL, HP.CDHISTPADR, CT.NRSEQVENREC, CT.NRPARCELAREC,
                      CT.VRATUAREC, TP.CDCONTCTBL
                 FROM BAIXARECEBIDA BX, BOLETRECEBER BO, AJBOLREC AJ, CONTARECEBER CT,
                      NOTAFISCAL NF, TIPOAJRECEBER TP LEFT JOIN HISTPADR HP
                                                             ON HP.CDHISTPADR = TP.CDHISTPADR
                WHERE BX.CDFILIAL = @P_CDFILIAL
                  AND BX.NRBAIXAREC = @P_NRBAIXA
                  AND BX.CDFILIAL = BO.CDFILIBAIREC
                  AND BX.NRBAIXAREC = BO.NRBAIXAREC
                  AND BO.CDFILIAL = AJ.CDFILIAL
                  AND BO.NRLANBOLREC = AJ.NRLANBOLREC
                  AND BO.CDFILIAL = CT.CDFILIBOLREC
                  AND BO.NRLANBOLREC = CT.NRLANBOLREC
                  AND CT.CDFILIAL = NF.CDFILIAL
                  AND CT.NRLANCTONF = NF.NRLANCTONF
                  AND AJ.CDAJUCTREC = TP.CDAJUCTREC
                  AND TP.IDCTBAJCTREC = 'S';
            OPEN AJUSTES;
            FETCH NEXT FROM AJUSTES INTO @AJUSTES_NRLANBOLREC, @AJUSTES_CDFILIBAIREC, @AJUSTES_CDFILIEMIT,
                                        @AJUSTES_CDAJUCTREC, @AJUSTES_CDREDUCONT, @AJUSTES_CDCLIENTE,
                                        @AJUSTES_VRAJBOLREC, @AJUSTES_IDAJUCTREC, @AJUSTES_VRBOLREC,
                                        @AJUSTES_NRLANCTONF, @AJUSTES_CDFILIAL, @AJUSTES_CDHISTPADR,
                                        @AJUSTES_NRSEQVENREC, @AJUSTES_NRPARCELAREC, @AJUSTES_VRATUAREC, @AJUSTES_CDCONTCTBL;
            WHILE @@FETCH_STATUS = 0 BEGIN
               IF @AJUSTES_IDAJUCTREC = 'D' BEGIN
                  SET @V_FATOR = -1;
               END
               ELSE BEGIN
                  SET @V_FATOR = 1;
               END;

               EXEC CTB_HIST_REC @AJUSTES_CDHISTPADR, @AJUSTES_CDFILIAL, @AJUSTES_NRLANCTONF, @AJUSTES_NRSEQVENREC, @AJUSTES_NRPARCELAREC, @AJUSTES_CDAJUCTREC, @P_DSHISTPADR = @V_DSHISTPADR OUTPUT;

               SELECT @V_CDCENTCUST = CDCENTCUST
                 FROM FILIAL
                WHERE CDFILIAL = @AJUSTES_CDFILIEMIT;

               IF @V_CDCENTCUST IS NULL BEGIN
                  SELECT @V_CDCENTCUST = CDCENTCUST
                    FROM EMPRESA
                   WHERE CDEMPRESA = @P_CDEMPRESA;
               END;

               SET @V_CDCONTCTBL = @AJUSTES_CDCONTCTBL;

               SELECT @V_IDCOME = ISNULL(IDTIPOCOME, 'N'), @V_IDCCUS = IDCONTCCUS
                 FROM CONTCTBL
                WHERE CDCONTCTBL = @V_CDCONTCTBL;

               IF @V_IDCOME = 'B' BEGIN
                  SET @V_CODCOMEAUX = @AJUSTES_CDREDUCONT;
               END
               ELSE IF @V_IDCOME = 'C' BEGIN
                  SET @V_CODCOMEAUX = @AJUSTES_CDCLIENTE;
               END
               ELSE BEGIN
                  SET @V_IDCOME = 'N';
                  SET @V_CODCOMEAUX = NULL;
               END;

               IF @V_SEQPARTIDA IS NULL BEGIN
                  SET @V_SEQPARTIDA = 0;
               END;

               SET @V_SEQPARTIDA = @V_SEQPARTIDA + 1;
               SET @V_PARTIDAAUX = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_SEQPARTIDA), 2);
               SET @V_VRAJUSTE = (@AJUSTES_VRATUAREC  * 100) / @AJUSTES_VRBOLREC;
               SET @V_VRAJUSTE = ROUND(((@AJUSTES_VRAJBOLREC * @V_VRAJUSTE) / 100) * @V_FATOR, 2);

               INSERT INTO LANCCTBTEMP
                  (CDEMPRESA, NRLANCCTBTEMP, CDDOCUTEMP, NRSEQCTBTEMP, CDCONTCTBL, CDHISTPADR,
                   DSHISTCTB, DTLANCCTBTEMP, VRLANCCTBTEMP, IDLANCCTBCOME, CDLANCCTBCOME, IDSISTEMA)
               VALUES
                  (@P_CDEMPRESA, @V_NRLANCTEMP, @V_DOCUMENTO, @V_PARTIDAAUX, @V_CDCONTCTBL, @V_CDHISTPADR,
                  @V_DSHISTPADR,  @V_DTBAIXA, @V_VRAJUSTE, @V_IDCOME, @V_CODCOMEAUX, 'REC');

               SET @V_TOTAJUSTE = @V_VRAJUSTE * @V_FATOR;

               IF @V_CONTRAT = 'S' BEGIN
                  IF @V_IDCCUS <> 'O' BEGIN
                     SET @V_TOTRATAJ = 0;
                     SET @V_RATSEQ = 0;
                     SELECT @V_COUNT = COUNT(*)
                       FROM RATTPAJR
                      WHERE CDAJUCTREC = @AJUSTES_CDAJUCTREC;

                     IF @V_COUNT <> 0 BEGIN
                        DECLARE RATAJ CURSOR FOR
                           SELECT CDCENTCUST, CDFIRATTPAJR, CDFILIAL, VRPERATTPAJR
                             FROM RATTPAJR
                            WHERE CDAJUCTREC = @AJUSTES_CDAJUCTREC;
                        OPEN RATAJ;
                        FETCH NEXT FROM RATAJ INTO @RATAJ_CDCENTCUST, @RATAJ_CDFIRATTPAJR,
                                                   @RATAJ_CDFILIAL, @RATAJ_VRPERATTPAJR;
                        WHILE @@FETCH_STATUS = 0 BEGIN
                           SET @V_VRAJUSTE = (@V_TOTAJUSTE * @RATAJ_VRPERATTPAJR) / 100;

                           SET @V_RATSEQ = @V_RATSEQ + 1;
                           SET @V_RATSEQAUX = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_RATSEQ), 2);
                           SELECT @V_CDFILIAL = CASE @RATAJ_CDFIRATTPAJR WHEN '----' THEN @AJUSTES_CDFILIEMIT ELSE @RATAJ_CDFIRATTPAJR END;
                           INSERT INTO RATECTBTEMP
                              (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP,
                               CDFILIAL, CDCENTCUST,
                               VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                           VALUES
                              (@P_CDEMPRESA, @V_NRLANCTEMP, @V_PARTIDAAUX,
                               @V_CDFILIAL, @RATAJ_CDCENTCUST,
                               @V_VRAJUSTE, @V_DTBAIXA, @V_RATSEQAUX);

                           SET @V_TOTRATAJ = @V_TOTRATAJ + @V_VRAJUSTE;
                           SET @V_CDCENTCUST = @RATAJ_CDCENTCUST;
                           FETCH NEXT FROM RATAJ INTO @RATAJ_CDCENTCUST, @RATAJ_CDFIRATTPAJR,
                                                   @RATAJ_CDFILIAL, @RATAJ_VRPERATTPAJR;
                        END;
                     END
                     ELSE BEGIN
                        SET @V_RATSEQ = @V_RATSEQ + 1;
                        SET @V_RATSEQAUX = RIGHT(REPLICATE('0', 5) + CONVERT(VARCHAR, @V_RATSEQ), 2);
                        SELECT @V_CDCENTCUST = CDCENTCUST
                          FROM FILIAL
                         WHERE CDFILIAL = @AJUSTES_CDFILIEMIT;

                        IF @V_CDCENTCUST IS NULL BEGIN
                           SELECT @V_CDCENTCUST = CDCENTCUST
                             FROM EMPRESA
                            WHERE CDEMPRESA = @P_CDEMPRESA;
                        END;

                        SET @V_VRAJUSTE = ROUND(@V_VRAJUSTE * @V_FATOR, 2);
                        INSERT INTO RATECTBTEMP
                           (CDEMPRESA, NRLANCCTBTEMP, NRSEQCTBTEMP, CDFILIAL, CDCENTCUST, VRRATECTBTEMP, DTCOMPCTBTEMP, NRSEQRATTEMP)
                        VALUES
                           (@P_CDEMPRESA, @V_NRLANCTEMP, @V_PARTIDAAUX, @AJUSTES_CDFILIEMIT, @V_CDCENTCUST,
                           @V_VRAJUSTE, @V_DTBAIXA, @V_RATSEQAUX);

                        SET @V_TOTRATAJ = @V_TOTRATAJ + (@V_VRAJUSTE * @V_FATOR);
                        SET @V_CDFILIAL = @AJUSTES_CDFILIEMIT;
                        SET @V_CDCENTCUST = @V_CDCENTCUST;
                     END;
                     IF @V_TOTRATAJ <> @V_TOTAJUSTE BEGIN
                        SET @V_RATSEQ = @V_RATSEQ + 1;
                        SET @V_TOTRATAJ = @V_TOTRATAJ - @V_TOTAJUSTE;
                        UPDATE RATECTBTEMP
                           SET VRRATECTBTEMP = VRRATECTBTEMP + @V_TOTRATAJ
                         WHERE NRSEQCTBTEMP = @V_PARTIDAAUX
                           AND CDFILIAL = @V_CDFILIAL
                           AND CDCENTCUST = @V_CDCENTCUST
                           AND NRLANCCTBTEMP = @V_NRLANCTEMP
                           AND CDEMPRESA = @P_CDEMPRESA;
                     END;
                  END;
               END;
               FETCH NEXT FROM AJUSTES INTO @AJUSTES_NRLANBOLREC, @AJUSTES_CDFILIBAIREC, @AJUSTES_CDFILIEMIT,
                                            @AJUSTES_CDAJUCTREC, @AJUSTES_CDREDUCONT, @AJUSTES_CDCLIENTE,
                                            @AJUSTES_VRAJBOLREC, @AJUSTES_IDAJUCTREC, @AJUSTES_VRBOLREC,
                                            @AJUSTES_NRLANCTONF, @AJUSTES_CDFILIAL, @AJUSTES_CDHISTPADR,
                                            @AJUSTES_NRSEQVENREC, @AJUSTES_NRPARCELAREC, @AJUSTES_VRATUAREC, @AJUSTES_CDCONTCTBL;
            END;
            CLOSE AJUSTES;
            DEALLOCATE AJUSTES;
         END;
      END;

      /*VERIFICACAO DE ERROS NAS PARTIDAS E NO LANCAMENTO CONTABIL*/
      EXEC VERIFICA_ERRO_CTB @V_NRLANCTEMP, @P_CDEMPRESA;
      SELECT @V_COUNT = COUNT(*)
        FROM ERROCTBTEMP
       WHERE NRLANCCTBTEMP = @V_NRLANCTEMP
         AND CDEMPRESA = @P_CDEMPRESA;

      IF @V_COUNT = 0 BEGIN
         UPDATE BAIXARECEBIDA
            SET NRLCTBBREC = @V_NRLANCTEMP
          WHERE NRBAIXAREC = @P_NRBAIXA
            AND CDFILIAL   = @P_CDFILIAL;
      END;

      EXEC GRAVA_LANC_CTB @V_NRLANCTEMP, @P_CDEMPRESA;
      SET @P_NRLANCCTB = @V_NRLANCTEMP;
   END;
END;
GO


-- VERSAO --
EXEC TEKNISA.ATUVEROBJ 'CTB_REC_BAIXA','5.50.000';
GO

