var RelationsController = function($scope, metaDataFactory, ScreenService, templateManager) {

	var widget = $scope.widget;
	widget.relationsDataSourcePreviousData = null;

	// Loads datasources
	widget.parentsDataSource = metaDataFactory.dataSourceFactory(widget.parentsDataSource, widget.getDataSourceFilter('parentsDataSourceFilter'), widget);
	widget.childsDataSource = metaDataFactory.dataSourceFactory(widget.childsDataSource, widget.getDataSourceFilter('childsDataSourceFilter'), widget);
	widget.relationsDataSource = metaDataFactory.dataSourceFactory(widget.relationsDataSource, widget.getDataSourceFilter('relationsDataSourceFilter'), widget);

	if (!widget._relationEditAction) {
		widget._relationEditAction = metaDataFactory.actionFactory({
			"name": "edit",
			"isVisible": true,
			"icon": "pencil",
			"showAsAction": "always_list",
			"events": [
				{
					"name": "ActionEvent",
					"code": "args.owner.widget.editActionClick();"
				}
			]
		}, widget, true);
	}

	if (!widget._relationCancelAction) {
		widget._relationCancelAction = metaDataFactory.actionFactory({
			"name": "cancel",
			"isVisible": true,
			"label": ScreenService.i18n("Cancel"),
			"showAsAction": "back_edit",
			"hideIcon": true,
			"events": [
				{
					"name": "ActionEvent",
					"code": "args.owner.widget.cancelActionClick();"
				}
			]
		}, widget, true);
	}

	if (!widget._relationSaveAction) {
		widget._relationSaveAction = metaDataFactory.actionFactory({
			"name": "save",
			"isVisible": true,
			"label": ScreenService.i18n("Save"),
			"showAsAction": "never_edit",
			"events": [
				{
					"name": "ActionEvent",
					"code": "args.owner.widget.saveActionClick();"
				}
			]
		}, widget, true);
	}

	widget.editActionClick = function() {
		widget.relationsDataSourcePreviousData = Util.clone(widget.relationsDataSource.data);
		$scope.startRelating(widget.parentsDataSource.data[0]);
		widget.edit();
	};

	widget.cancelActionClick = function() {
		widget.relationsDataSource.data = widget.relationsDataSourcePreviousData;
		widget.relationsDataSourcePreviousData = null;
		$scope.startRelating(null);
		widget.list();
	};

	widget.saveActionClick = function() {
		$scope.startRelating(null);
		widget.list();

		if (widget.onSaveRelations) {
			widget.onSaveRelations({data: widget.relationsDataSource.data });
		}
	};
};

ZeedhiController.controller('RelationsController', RelationsController);